#include <proc.h>

static struct {
    struct thread *first;
    struct thread *last;
} run_q = {0,0};

static struct thread *scheduler_thread;

static struct thread *scheduler_next()
{
    struct thread *ret = run_q.first;
    if(run_q.first && !(run_q.first = run_q.first->q_next))
        run_q.last = 0;
    return ret;
}

void scheduler_insert(struct thread *new)
{
    if(run_q.last) {
        run_q.last->q_next = new;
        run_q.last = new;
    } else {
        run_q.first = run_q.last = new;
    }
    new->q_next = 0;
}

void scheduler()
{
    while(1)
    {
        struct thread *new = 0;
        while(!(new = scheduler_next()));

        current_thread = new;
        switch_stack(&scheduler_thread->stack_ptr, &new->stack_ptr);

        scheduler_insert(current_thread);
        current_thread = 0;
    }
}

long k_sched_yield(long, long, long, long, long, long)
{
    switch_stack(&current_thread->stack_ptr, &scheduler_thread->stack_ptr);
    return 0;
}

void start_scheduler()
{
    scheduler_thread = new_thread(scheduler);
    scheduler_thread->tid = (uint64_t)-1;

    uint64_t stack;
    switch_stack(&stack, &scheduler_thread->stack_ptr);
}